#include "icfgram.h"
char *ZC_usage = "usage:  icf [-v] [-f] [-l length] [-w width] formdescfile session_file";
extern int exit();
int (*ZC_fn_eprint_exit)() = exit;
char opt_d;
char opt_v;
char opt_f;
char *opt_l;
char *opt_w;
static char *ae_malloc(n, s)
unsigned n;
char *s;
{
char *t;
static char ae_buf[1000];
static int offset;

if(s) n += strlen(s) + 1;
if(offset + n > 1000)
eprint("1expanding arguments, options and environment variables\n\
\tconsumes more than 1000 characters");
t = ae_buf + offset;
n = (n+3) & ~3;
offset += n;
if(s) strcpy(t, s);
return t;
} /* ae_malloc */

static char *arg_strings[2];
main(argc, argv)
char **argv;
{
char **new_argv, **save_argv, *s, *t, *ae_malloc(), *getenv();
int new_argc, save_argc, status, i;
static char *single[3];
static char badoptmix[] = "cannot set options -%s simultaneously";

t = badoptmix; /* supress compiler warning */
single[0] = *argv;
save_argv = argv;
save_argc = argc;
new_argv = argv+1;
new_argc = 0;
for(++argv, --argc; argc; ++argv, --argc) {
s = *argv;
if(*s != '-' || !s[1]) { /* regular arg, no options */
*new_argv++ = s;
++new_argc;
continue;
}

for(++s; *s; ++s)
switch(*s) {
case 'd': opt_d = 1; continue;
case 'v': opt_v = 1; continue;
case 'f': opt_f = 1; continue;
case 'l':
if(s[1]) opt_l = s+1;
else {
if(argc == 1) usage();
opt_l = *++argv;
--argc;
}
*s = 0;
break;
case 'w':
if(s[1]) opt_w = s+1;
else {
if(argc == 1) usage();
opt_w = *++argv;
--argc;
}
*s = 0;
break;
default: usage(); /* unknown option */
} /* end switch on option */
} /* end options */

status = 0;
argv = save_argv;
argc = ++new_argc;
if(argc < save_argc) argv[argc] = 0;
/* at this point it looks like main was called with just the args,
 * options are magically set. */
if(argc <= 2) usage();
if(argc > 3) usage();
arg_strings[0] = argv[1];
arg_strings[1] = argv[2];
argv[2] = argv[0]; argv += 2; argc -= 2;
status = flatmain(arg_strings[0], arg_strings[1]);
exit(status);
} /* main */

extern char *ZC_prevlink;
#define ZC_NEXTLINK(ptr, offset) *((char **)ptr+2*offset)
#define ZC_PREVLINK(ptr, offset) *((char **)ptr+2*offset + 1)
struct domain_member *find_domain_member(list, t)
struct list_domain_member *list;
struct domain_member *t;
{
long rc;
struct domain_member *s = 0;

if(!list) eclib_error(NODE_NULL_PTR, 7);
if(!t) eclib_error(NODE_NULL_PTR, 8);
ZC_prevlink = 0;
for(s=list->head; s; s=s->next) {
rc = cmp_domain_member(s, t);
if(rc >= 0) break;
ZC_prevlink = (char *)s;
}
if(rc) s = 0;
return s;
} /* find_domain_member */

struct domain_member *find_extract_domain_member(list, t)
struct list_domain_member *list;
struct domain_member *t;
{
struct domain_member *s = find_domain_member(list, t);
if(s) /* drop all links */
ZC_extract(list, s, STRUCT_domain_member, 0);
return s;
} /* find_extract_domain_member */

struct domain_member *find_domain_member_1(list, t)
struct list_domain_member *list;
struct domain_member *t;
{
long rc;
struct domain_member *s = 0;

if(!list) eclib_error(NODE_NULL_PTR, 7);
if(!t) eclib_error(NODE_NULL_PTR, 8);
ZC_prevlink = 0;
for(s=list->head_1; s; s=s->next_1) {
rc = cmp_domain_member_1(s, t);
if(rc >= 0) break;
ZC_prevlink = (char *)s;
}
if(rc) s = 0;
return s;
} /* find_domain_member_1 */

struct domain_member *find_extract_domain_member_1(list, t)
struct list_domain_member *list;
struct domain_member *t;
{
struct domain_member *s = find_domain_member_1(list, t);
if(s) /* drop all links */
ZC_extract(list, s, STRUCT_domain_member, 0);
return s;
} /* find_extract_domain_member_1 */

struct domain_member *ZC_insert_domain_member(list, t, copy)
struct list_domain_member *list;
struct domain_member *t;
{
struct domain_member *s = 0;

if(!t) eclib_error(NODE_NULL_PTR, 9);
if(!list) eclib_error(NODE_NULL_PTR, 10);
if(copy) t = copy_domain_member(t);

/* call ZC_o_listlink for each ordering of this list */
s = find_domain_member(list, t);
if(s) eclib_error(NODE_DUPLICATE, STRUCT_domain_member);
ZC_o_listlink((char **)list, (char*)t, 0);
s = find_domain_member_1(list, t);
if(s) eclib_error(NODE_DUPLICATE, STRUCT_domain_member);
ZC_o_listlink((char **)list, (char*)t, 1);

++list->n_nodes;
return t;
} /* ZC_insert_domain_member */

struct domain *find_domain(list, t)
struct list_domain *list;
struct domain *t;
{
long rc;
struct domain *s = 0;

if(!list) eclib_error(NODE_NULL_PTR, 7);
if(!t) eclib_error(NODE_NULL_PTR, 8);
ZC_prevlink = 0;
for(s=list->head; s; s=s->next) {
rc = cmp_domain(s, t);
if(rc >= 0) break;
ZC_prevlink = (char *)s;
}
if(rc) s = 0;
return s;
} /* find_domain */

struct domain *find_extract_domain(list, t)
struct list_domain *list;
struct domain *t;
{
struct domain *s = find_domain(list, t);
if(s) /* drop all links */
ZC_extract(list, s, STRUCT_domain, 0);
return s;
} /* find_extract_domain */

struct domain *find_domain_1(list, t)
struct list_domain *list;
struct domain *t;
{
long rc;
struct domain *s = 0;

if(!list) eclib_error(NODE_NULL_PTR, 7);
if(!t) eclib_error(NODE_NULL_PTR, 8);
ZC_prevlink = 0;
for(s=list->head_1; s; s=s->next_1) {
rc = cmp_domain_1(s, t);
if(rc >= 0) break;
ZC_prevlink = (char *)s;
}
if(rc) s = 0;
return s;
} /* find_domain_1 */

struct domain *find_extract_domain_1(list, t)
struct list_domain *list;
struct domain *t;
{
struct domain *s = find_domain_1(list, t);
if(s) /* drop all links */
ZC_extract(list, s, STRUCT_domain, 0);
return s;
} /* find_extract_domain_1 */

struct domain *ZC_insert_domain(list, t, copy)
struct list_domain *list;
struct domain *t;
{
struct domain *s = 0;

if(!t) eclib_error(NODE_NULL_PTR, 9);
if(!list) eclib_error(NODE_NULL_PTR, 10);
if(copy) t = copy_domain(t);

/* call ZC_o_listlink for each ordering of this list */
s = find_domain(list, t);
if(s) eclib_error(NODE_DUPLICATE, STRUCT_domain);
ZC_o_listlink((char **)list, (char*)t, 0);
s = find_domain_1(list, t);
if(s) eclib_error(NODE_DUPLICATE, STRUCT_domain);
ZC_o_listlink((char **)list, (char*)t, 1);

++list->n_nodes;
return t;
} /* ZC_insert_domain */

struct list_domain  domains;
static struct expstr ZC_null_expstr;
static char ZC_scanstring[200];
char *gather_string(quote, m4)
char quote, m4;
{
int k, c, old_c;
char octcount, octval, escmode;
short nestlevel;

escmode = octcount = k = 0;
nestlevel = 1;

top:
c = io_get();
if(c == EOF)
eclib_error(SCAN_EOF_STRING);
if(escmode) {
escmode = 0;
old_c = c;
if(c != quote)
switch(c) {
case '\n': goto top;
case 'f': c = '\f'; break;
case 'n': c = '\n'; break;
case 't': c = '\t'; break;
case 'b': c = '\b'; break;
case 'r': c = '\r'; break;
case '\\': break;
default:
if(k < STRING_LENGTH-1)
ZC_scanstring[k++] = '\\';
}
if(k < STRING_LENGTH-1)
ZC_scanstring[k++] = c;
if(c != '\n' || old_c == 'n') goto top;
}

if(c == '\n') { ZC_scanstring[k] = 0; eclib_error(SCAN_NL_STRING, 0); return ZC_scanstring; }
if(c == '\\') { escmode = 1; goto top; }
if(c == quote) {
endstring:
if(k >= STRING_LENGTH-1)
eclib_error(SCAN_LONG_STRING, STRING_LENGTH);
ZC_scanstring[k] = 0;
return ZC_scanstring;
}
if(k < STRING_LENGTH-1)
ZC_scanstring[k++] = c;
goto top;
} /* gather_string */

FILE **ZC_divertfiles[] = {
0,0};
char ZC_divertnest[] = {
0,0};
char ZC_divertchars[][4] = {
{'/','*','*','/'},
{0,0,0,0}
};
char ZC_nl_significant = 0;
char *ZC_t_names[] = { "end-of-file",
"error",
"NUMBER",
"STRING",
"NUMBER_HUGE",
"WORD",
"ASG",
"OR",
"AND",
"NOT",
"RELOP",
"PIPE",
"ADDOP",
"MULOP",
"USING",
"TEXT",
"TYPE",
"STRINGMOD",
"BOOLCONST",
"MONEYCONST",
"COMMA",
"COLON",
"SEMI",
"LC",
"RC",
"LP",
"RP",
"LB",
"RB",
"ARRAY",
"AGGR",
"POP",
"COND",
"ELSE",
"LOOPARRAY",
"CONT",
"DOMAIN",
"ECHO",
"DECLARE",
"ASK",
"NEXTASK",
"CALL",
"FUNCTION",
"RETURNING",
"RETURN",
"EXPLAIN",
"QUESTION",
0};
char *ZC_tok_strings[] = { "unknown token",
"=",
"or",
"and",
"not",
"==",
"!=",
"<",
"<=",
">",
">=",
"|",
"+",
"-",
"*",
"/",
"%",
"using",
"`",
"money",
"int",
"string",
"raw",
"downshift",
"pretty",
"upshift",
"bool",
"date",
"false",
"true",
"$",
",",
":",
";",
"{",
"}",
"(",
")",
"[",
"]",
"array",
"max",
"min",
"length",
"sum",
"avg",
"pop",
"popall",
"if",
"while",
"else",
"looparray",
"continue",
"break",
"domain",
"echo",
"decl",
"ask",
"nextask",
"call",
"function",
"returning",
"return",
"explain",
"prompt",
0};
/* reserved words */
struct {
char *key;
short gramval; /* number that determines the gramatical significance of this token */
short tokval; /* number associated with this token */
short extval; /* user-defined number asssociated with this token,
	passed to other routines.
	For example, the tokens "<=", ">", etc may be given token numbers
	of 1 through 6, somewhat arbitrary, with a fixed
	grammar number of 25, since they all have the same affect on parsing.
	The extensions are numbers that tell the interpreter
	or compiler exactly how to compare the two operands. */
int (*fn)(); /* function to call if this keyword appears */
} keywords[] = {
{ "and", 8, 3, 0, 0},
{ "array", 29, 40, 0, 0},
{ "ask", 39, 57, 0, 0},
{ "avg", 30, 45, 0, 0},
{ "bool", 16, 26, TYPE_BOOL, 0},
{ "break", 35, 53, BLK_BREAK, 0},
{ "call", 41, 59, 0, 0},
{ "continue", 35, 52, BLK_CONT, 0},
{ "date", 16, 27, TYPE_DATE, 0},
{ "decl", 38, 56, BLK_DECL, 0},
{ "domain", 36, 54, 0, 0},
{ "downshift", 17, 23, 1, 0},
{ "echo", 37, 55, BLK_ECHO, 0},
{ "else", 33, 50, BLK_IF, 0},
{ "explain", 45, 63, 0, 0},
{ "false", 18, 28, 0, 0},
{ "function", 42, 60, 0, 0},
{ "if", 32, 48, BLK_IF, 0},
{ "int", 16, 20, TYPE_INT, 0},
{ "length", 30, 43, 0, 0},
{ "looparray", 34, 51, 0, 0},
{ "max", 30, 41, 0, 0},
{ "min", 30, 42, 0, 0},
{ "money", 16, 19, TYPE_MONEY, 0},
{ "nextask", 40, 58, 0, 0},
{ "not", 9, 4, 0, 0},
{ "or", 7, 2, 0, 0},
{ "pop", 31, 46, 6, 0},
{ "popall", 31, 47, 11, 0},
{ "pretty", 17, 24, 2, 0},
{ "prompt", 46, 64, BLK_QUES, 0},
{ "raw", 17, 22, 0, 0},
{ "return", 44, 62, 0, 0},
{ "returning", 43, 61, 0, 0},
{ "string", 16, 21, TYPE_STRING, 0},
{ "sum", 30, 44, 0, 0},
{ "true", 18, 29, 1, 0},
{ "upshift", 17, 25, 3, 0},
{ "using", 14, 17, 0, 0},
{ "while", 32, 49, BLK_WHILE, 0},
{0,0,0,0,0}
};

extern int scanner_base, err_base;

int lex_go()
{
/* recall that input-character variable must be int, for EOF */
int c;
char y0, *s;
int i, left, right; /* for binary search of keywords */
short rc;
static char w[WORD_LENGTH]; /* store word */

top:
c = io_skipwhite();
i = 0;
ZC_inp_parseval.tok.val = ZC_inp_parseval.tok.extend = 0;

switch(c) {
case EOF: return 0;
case '!':
c = io_get();
 switch(c) {
case '=':
ZC_inp_parseval.tok.val = 6;
return 10;
default: io_unget(c);
} /* end switch on char[1] */
c = '!';
break;
case '$':
ZC_inp_parseval.tok.val = 30;
return parsemoney(19);
case '%':
ZC_inp_parseval.tok.val = 16;
return 13;
case '(':
ZC_inp_parseval.tok.val = 36;
return 25;
case ')':
ZC_inp_parseval.tok.val = 37;
return 26;
case '*':
ZC_inp_parseval.tok.val = 14;
return 13;
case '+':
ZC_inp_parseval.tok.val = 12;
return 12;
case ',':
ZC_inp_parseval.tok.val = 31;
return 20;
case '-':
ZC_inp_parseval.tok.val = 13;
return 12;
case '/':
ZC_inp_parseval.tok.val = 15;
return 13;
case ':':
ZC_inp_parseval.tok.val = 32;
return 21;
case ';':
ZC_inp_parseval.tok.val = 33;
return 22;
case '<':
c = io_get();
 switch(c) {
case '=':
ZC_inp_parseval.tok.val = 8;
return 10;
default: io_unget(c);
} /* end switch on char[1] */
ZC_inp_parseval.tok.val = 7;
return 10;
case '=':
c = io_get();
 switch(c) {
case '=':
ZC_inp_parseval.tok.val = 5;
return 10;
default: io_unget(c);
} /* end switch on char[1] */
ZC_inp_parseval.tok.val = 1;
return 6;
case '>':
c = io_get();
 switch(c) {
case '=':
ZC_inp_parseval.tok.val = 10;
return 10;
default: io_unget(c);
} /* end switch on char[1] */
ZC_inp_parseval.tok.val = 9;
return 10;
case '[':
ZC_inp_parseval.tok.val = 38;
return 27;
case ']':
ZC_inp_parseval.tok.val = 39;
return 28;
case '`':
ZC_inp_parseval.tok.val = 18;
return skip_to_etext(15);
case '{':
ZC_inp_parseval.tok.val = 34;
return 23;
case '|':
ZC_inp_parseval.tok.val = 11;
return 11;
case '}':
ZC_inp_parseval.tok.val = 35;
return 24;
case '"':
ZC_inp_parseval.s = gather_string(c, 0);
ZC_inp_parseval.sc = string_to_code(ZC_inp_parseval.s);
return GRAM_STRING;
} /* end switch looking for symbolic token */

if(isalpha(c) || c == '_') { /* word */
do {
if(i < WORD_LENGTH-1) w[i++] = c;
c = io_get();
} while(isalnum(c) || c == '_');
w[i] = 0;
io_unget(c);

/* look for keyword */
c = w[0];
left = -1, right = sizeof(keywords)/sizeof(keywords[0]);
while(right-left > 1) {
i = (left + right) / 2;
s = keywords[i].key;
rc = strcmp(s, w);
if(rc > 0) { right = i; continue; }
if(rc < 0) { left = i; continue; }

/* keyword found */
ZC_inp_parseval.tok.val = keywords[i].tokval;
ZC_inp_parseval.tok.extend = keywords[i].extval;
rc = keywords[i].gramval;
if(keywords[i].fn) rc = (*keywords[i].fn)(rc);
return rc;
} /* end loop searching for keywords */

ZC_inp_parseval.sc = string_to_code(w);
return identmatch(GRAM_WORD);
} /* end word */

if(isdigit(c)) { /* number */
y0 = 0;
ZC_scanstring[i++] = c;
c = io_get();
if(ZC_scanstring[0] == '0') {
y0 = 1; /* leading zeros */
if(toupper(c) == 'X') { ZC_scanstring[i++] = c; c = io_get(); }
} /* end looking for C style 0...octal or 0x...hex */

more_number:
if(isalnum(c)) {
do {
if(!y0 || c != '0') {
y0 = 0;
if(i < STRING_LENGTH-1) ZC_scanstring[i++] = c;
}
c = io_get();
} while(isalnum(c));
}

/* number can spread across multiple lines */
if(c == '\\') {
c = io_get();
if(c == '\n') {
c = io_get();
goto more_number;
}
}

/* number has now been read into ZC_scanstring */
io_unget(c);
ZC_scanstring[i] = 0;
if(i == STRING_LENGTH-1)
eclib_error(SCAN_LONG_STRING, STRING_LENGTH);

/* convert number into long, if possible */
i = zc_strtol(ZC_scanstring, &s, &ZC_inp_parseval.l);
if(i) {
if(i == -1) i = SCAN_BAD_DIGIT;
else {
i = SCAN_PRECISION_LONG;
}
eclib_error(i, *s | (err_base << 8));
} /* abnormal return from zc_strtol */
return GRAM_NUMBER;
} /* end number */

eclib_error(SCAN_BADCHAR, c);
goto top;
} /* lex_go */

short ZC_prod_length[]={
0,0,4,7,9,2,6,3,7,5,
7,5,5,2,4,3,7,3,7,3,
7,1,5,9,5,2,6,15,11,15,
5,9,9,7,5,5,9,7,5,7,
9,9,15,5,1,5,3,3,1,3,
9,11,9,7,7,7,5,7,7,7,
7,5,7,7,9,3,3,3,3,3 };
short ZC_nt_base = 50;
char *ZC_nt_names[] = {
"$start",
"call2",
"instruct",
"rescond",
"loopcond",
"qdecl",
"array",
"vtype",
"retlist",
"parm",
"fn1",
"domlist",
"exp",
"arlist",
"input",
"stmt",
"fn2",
"parmlist",
"stmtlist",
"arglist",
"call1",
0};

short ZC_rules[] = {
50,64,0,
64,
64,64,65,
64,64,66,65,
66,60,25,67,26,
67,59,
67,67,20,59,
58,5,
58,58,20,5,
59,16,5,
59,16,17,5,
59,5,5,
60,42,5,
68,65,
68,68,65,
61,3,
61,61,20,3,
63,5,
63,63,20,5,
69,62,
69,62,20,69,
53,
54,34,63,
70,51,25,69,26,
51,41,5,
65,22,
65,23,68,24,
65,36,5,3,23,61,24,22,
65,57,39,15,52,22,
65,57,39,15,40,15,52,22,
65,57,22,
65,57,6,62,22,
65,5,6,62,22,
65,31,5,22,
65,35,22,
65,70,22,
65,70,43,58,22,
65,44,69,22,
65,44,22,
65,37,15,22,
65,37,2,15,22,
65,32,53,62,65,
65,32,53,62,65,33,53,65,
65,54,65,
52,
52,45,15,
55,46,
55,38,
56,
56,29,
57,55,56,16,5,
57,55,56,16,17,5,
57,55,56,5,5,
57,55,56,5,
62,62,7,62,
62,62,8,62,
62,9,62,
62,62,10,62,
62,62,13,62,
62,62,11,62,
62,62,12,62,
62,12,62,
62,62,14,3,
62,25,62,26,
62,30,25,5,26,
62,5,
62,2,
62,19,
62,18,
62,3,
-1};
short ZC_rule_offset[]={
0,3,4,7,11,16,18,22,24,28,
31,35,38,41,43,46,48,52,54,58,
60,64,65,68,73,76,78,82,90,96,
104,107,112,117,121,124,127,132,136,139,
143,148,153,161,164,165,168,170,172,173,
175,180,186,191,195,199,203,206,210,214,
218,222,225,229,233,238,240,242,244,246,
248,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0 };
short ZC_exca[] ={
-1, 1,
	0, -1,
	-2, 0,
	0,0};
short ZC_def[]={
1,-2,2,0,25,0,0,0,0,0,
0,0,0,0,21,0,0,48,0,0,
0,46,47,0,3,0,13,0,0,30,
0,0,0,34,35,0,0,38,19,0,
0,0,0,65,66,67,68,69,0,0,
0,43,0,0,49,0,22,17,12,24,
14,26,0,44,0,0,33,0,7,37,
0,0,0,0,0,0,0,0,56,61,
0,0,39,0,0,0,5,0,0,0,
53,0,0,0,0,0,0,31,32,0,
36,20,54,55,57,58,59,60,62,63,
0,40,41,4,0,9,0,11,50,0,
52,23,18,0,15,28,44,45,8,64,
21,6,10,51,0,0,0,0,16,27,
29,42 };
short ZC_chk[]={
-1000,-14,-15,-16,22,23,36,-7,5,31,
35,-20,44,37,32,-4,-10,-5,-1,34,
42,46,38,41,-15,-18,-15,5,39,22,
6,6,5,22,22,43,-19,22,-12,9,
12,25,30,5,2,19,18,3,15,2,
-3,-15,25,-6,29,25,-13,5,5,5,
-15,24,3,15,-12,-12,22,-8,5,22,
20,7,8,10,13,11,12,14,-12,-12,
-12,25,22,15,-12,-17,-9,16,5,16,
5,-19,20,23,-2,40,45,22,22,20,
22,-19,-12,-12,-12,-12,-12,-12,3,26,
5,22,-15,26,20,5,17,5,5,17,
5,26,5,-11,3,22,15,15,5,26,
33,-9,5,5,20,24,-2,-3,3,22,
22,-15 };
short ZC_yylast = 239;
short ZC_act[]={
2,50,94,86,24,38,26,96,95,130,
54,34,36,96,114,81,51,30,129,121,
113,55,8,52,71,72,60,73,75,76,
74,77,35,29,134,93,64,65,135,4,
5,99,140,100,139,78,79,80,9,14,
28,19,10,6,13,22,84,125,23,111,
82,12,69,21,66,33,92,127,91,8,
72,49,73,75,76,74,77,102,103,104,
105,106,107,101,48,112,4,5,61,73,
75,76,74,77,8,9,14,118,19,10,
6,13,22,115,77,23,88,133,12,119,
21,4,5,74,77,116,31,87,131,8,
9,14,126,19,10,6,13,22,83,136,
23,20,137,12,63,21,4,5,141,75,
76,74,77,90,132,9,14,128,19,10,
6,13,22,122,89,23,44,47,12,43,
21,138,120,39,44,47,40,43,76,74,
77,39,46,45,40,117,37,110,68,41,
46,45,59,58,42,57,32,41,124,27,
71,72,42,73,75,76,74,77,71,72,
108,73,75,76,74,77,62,11,25,109,
85,71,72,98,73,75,76,74,77,3,
1,56,123,16,71,72,97,73,75,76,
74,77,67,7,53,17,15,70,18 };
short ZC_pact[]={
-1000,89,-1000,114,-1000,114,184,11,110,181,
43,-11,154,69,-1000,114,-2,-19,-4,180,
178,-1000,-1000,177,-1000,64,-1000,203,119,-1000,
162,162,42,-1000,-1000,173,40,-1000,217,162,
162,162,-10,-1000,-1000,-1000,-1000,-1000,38,113,
162,-1000,101,138,-1000,162,46,-1000,-1000,-1000,
-1000,-1000,12,-32,204,191,-1000,21,-1000,-1000,
162,162,162,162,162,162,162,197,79,100,
183,172,-1000,37,17,-6,-1000,98,170,92,
157,-7,148,185,35,107,52,-1000,-1000,142,
-1000,-1000,62,79,128,90,156,100,-1000,-1000,
-8,-1000,-24,-1000,101,-1000,139,-1000,-1000,102,
-1000,-1000,-1000,14,-1000,-1000,-38,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,158,22,20,114,-1000,-1000,
-1000,-1000 };
short ZC_pgo[]={
0,238,2,1,236,235,234,233,232,3,
223,222,5,221,220,0,219,210,208,12,
207 };
char *ZC_stacktop;
char ZC_recflag; /* error recovery */
ZC_gramunion ZC_curr_parseval, ZC_inp_parseval;
short ZC_gramunion_size = sizeof(ZC_gramunion);
int ZC_curr_token;

parser_rules(prodnum)
{
switch(prodnum) {
case 3: simple_stmt(BLK_ENDFN,
(str_code)0);
 break;
case 4: endargs(0);
 break;
case 7: ZC_curr_parseval.block = make_vtype(BLK_ASG,
0,
(str_code)0,
0,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 8: ZC_curr_parseval.block = make_vtype(BLK_ASG,
0,
(str_code)0,
0,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 9: ZC_curr_parseval.block = make_vtype(BLK_ASG,
0,
(str_code)0,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
2,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 10: ZC_curr_parseval.block = make_vtype(BLK_ASG,
0,
(str_code)0,
((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 11: ZC_curr_parseval.block = make_vtype(BLK_ASG,
0,
((ZC_gramunion *) ZC_stacktop)[-2].sc,
0,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 12: ZC_curr_parseval.block = make_vtype(BLK_DECL,
0,
(str_code)0,
TYPE_FN,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 15: ZC_curr_parseval.domain = setdom_mm((struct domain *)0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 16: ZC_curr_parseval.domain = setdom_mm(((ZC_gramunion *) ZC_stacktop)[-3].domain,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 17: ZC_curr_parseval.expstr = mkarlist(ZC_null_expstr,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 18: ZC_curr_parseval.expstr = mkarlist(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 19: pusharg(((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 20: pusharg(((ZC_gramunion *) ZC_stacktop)[-3].expstr);
 break;
case 21: ZC_curr_parseval.tok.extend = cond_reserve_block();
 break;
case 22: ZC_curr_parseval.tok.extend = start_looparray(((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 23: callfunc(((ZC_gramunion *) ZC_stacktop)[-4].sc);
 break;
case 24: ZC_curr_parseval.sc = frameset(((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 27: setdom(((ZC_gramunion *) ZC_stacktop)[-6].sc,
((ZC_gramunion *) ZC_stacktop)[-5].sc,
((ZC_gramunion *) ZC_stacktop)[-3].domain);
 break;
case 28: add_varblock(((ZC_gramunion *) ZC_stacktop)[-5].block,
((ZC_gramunion *) ZC_stacktop)[-3].l,
(long)0,
((ZC_gramunion *) ZC_stacktop)[-2].l);
 break;
case 29: add_varblock(((ZC_gramunion *) ZC_stacktop)[-7].block,
((ZC_gramunion *) ZC_stacktop)[-5].l,
((ZC_gramunion *) ZC_stacktop)[-3].l,
((ZC_gramunion *) ZC_stacktop)[-2].l);
 break;
case 30: add_varblock(((ZC_gramunion *) ZC_stacktop)[-2].block,
(long)0,
(long)0,
(long)0);
 break;
case 31: add_varasg(((ZC_gramunion *) ZC_stacktop)[-4].block,
((ZC_gramunion *) ZC_stacktop)[-2].expstr);
 break;
case 32: varassign(((ZC_gramunion *) ZC_stacktop)[-4].sc,
((ZC_gramunion *) ZC_stacktop)[-2].expstr);
 break;
case 33: simple_stmt(((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].sc);
 break;
case 34: simple_stmt(((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
(str_code)0);
 break;
case 35: endargs(1);
 break;
case 36: endargs(1);
 break;
case 37: simple_stmt(BLK_RET,
(str_code)0);
 break;
case 38: simple_stmt(BLK_RET,
(str_code)0);
 break;
case 39: echo_text((long)0,
((ZC_gramunion *) ZC_stacktop)[-2].l);
 break;
case 40: echo_text(((ZC_gramunion *) ZC_stacktop)[-3].l,
((ZC_gramunion *) ZC_stacktop)[-2].l);
 break;
case 41: add_condition(((ZC_gramunion *) ZC_stacktop)[-2].expstr,
((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-4].tok.extend,
0);
 break;
case 42: add_condition(((ZC_gramunion *) ZC_stacktop)[-5].expstr,
((ZC_gramunion *) ZC_stacktop)[-6].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-7].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend);
 break;
case 43: add_condition(ZC_null_expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
BLK_LA,
0);
 break;
case 44: ZC_curr_parseval.l = (long)0; break;
case 45: ZC_curr_parseval = ((ZC_gramunion *) ZC_stacktop)[-1]; break;
case 46: ZC_curr_parseval = ((ZC_gramunion *) ZC_stacktop)[-1]; break;
case 47: ZC_curr_parseval = ((ZC_gramunion *) ZC_stacktop)[-1]; break;
case 48: ZC_curr_parseval.tok.extend = 0; break;
case 49: ZC_curr_parseval.tok.extend = 1; break;
case 50: ZC_curr_parseval.block = make_vtype(((ZC_gramunion *) ZC_stacktop)[-4].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
(str_code)0,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
2,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 51: ZC_curr_parseval.block = make_vtype(((ZC_gramunion *) ZC_stacktop)[-5].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-4].tok.extend,
(str_code)0,
((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 52: ZC_curr_parseval.block = make_vtype(((ZC_gramunion *) ZC_stacktop)[-4].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].sc,
0,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 53: ZC_curr_parseval.block = make_vtype(((ZC_gramunion *) ZC_stacktop)[-3].tok.extend,
((ZC_gramunion *) ZC_stacktop)[-2].tok.extend,
(str_code)0,
0,
0,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 54: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 55: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 56: ZC_curr_parseval.expstr = monoexp(((ZC_gramunion *) ZC_stacktop)[-1].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val);
 break;
case 57: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 58: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 59: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 60: ZC_curr_parseval.expstr = buildexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].expstr);
 break;
case 61: ZC_curr_parseval.expstr = monoexp(((ZC_gramunion *) ZC_stacktop)[-1].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val);
 break;
case 62: ZC_curr_parseval.expstr = usingexp(((ZC_gramunion *) ZC_stacktop)[-3].expstr,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 63: ZC_curr_parseval = ((ZC_gramunion *) ZC_stacktop)[-2]; break;
case 64: ZC_curr_parseval.expstr = builtin(((ZC_gramunion *) ZC_stacktop)[-4].tok.val,
((ZC_gramunion *) ZC_stacktop)[-2].sc);
 break;
case 65: ZC_curr_parseval.expstr = wordexp(((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
case 66: ZC_curr_parseval.expstr = numexp(((ZC_gramunion *) ZC_stacktop)[-1].l,
TYPE_INT);
 break;
case 67: ZC_curr_parseval.expstr = numexp(((ZC_gramunion *) ZC_stacktop)[-1].l,
TYPE_MONEY);
 break;
case 68: ZC_curr_parseval.expstr = shortnumexp(((ZC_gramunion *) ZC_stacktop)[-1].tok.extend);
 break;
case 69: ZC_curr_parseval.expstr = scnumexp(((ZC_gramunion *) ZC_stacktop)[-1].sc);
 break;
} /* end switch on production number */
return -1; /* continue parsing */
} /* parser_rules */


/* globals corresponding to the externs above */
int icfdebug = 0, inbatch;
struct serial_inmem blist;
jmp_buf actjmp;
char streamuse[100];
FILE *formfile, *ansfile;
char *ansfilename;

short ZC_max_malloc = 200, ZC_max_struct = 3;
struct { char *block; unsigned char level; } ZC_inmem[200];
char *struct_avail[3][4];
long num_gets[3][4], num_frees[3][4], num_avails[3][4];
struct STRUCT_DESC struct_desc[] = {
{"domain_member", (sizeof(struct domain_member) + 3) & ~3,
 -1,0,0,0,0,2,4,-1,0,0,0},
{"domain", (sizeof(struct domain) + 3) & ~3,
 0,0,0,0,0,2,4,-1,0,0,0},
{"block", (sizeof(struct block) + 3) & ~3,
 -1,0,0,0,0,0,1,-1,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0}
};

struct IDX_DESC idx_desc[] = {
{0,0,0,0,0,0,0,0,0,0}
};


/* end of generated source file, copy this comment just to make sure
 * we aren't out of disk space.  The source copy routine checks for this. */
